/* export.c generated by valac 0.16.1, the Vala compiler
 * generated from export.vala, do not modify */

/*
 * DESCRIPTION      Welcome panel with tips and last open files.
 * PROJECT          Mind Map Architect
 * AUTHOR           Ondrej Tuma <mcbig@zeropage.cz>
 *
 * Copyright (C) Ondrej Tuma 2011
 * Code is present with BSD licence.
 */
/* modules: Glib*/

#include <glib.h>
#include <glib-object.h>
#include <gio/gio.h>
#include <stdlib.h>
#include <string.h>
#include <gdk/gdk.h>
#include <gtk/gtk.h>
#include <float.h>
#include <math.h>
#include <pango/pango.h>
#include <gee.h>
#include <stdio.h>
#include <libxml/xmlwriter.h>
#include <stdarg.h>
#include <time.h>
#include <cairo.h>


#define TYPE_NODE (node_get_type ())
#define NODE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_NODE, Node))
#define NODE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_NODE, NodeClass))
#define IS_NODE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_NODE))
#define IS_NODE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_NODE))
#define NODE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_NODE, NodeClass))

typedef struct _Node Node;
typedef struct _NodeClass NodeClass;
#define _g_free0(var) (var = (g_free (var), NULL))
typedef struct _NodePrivate NodePrivate;

#define TYPE_MIND_MAP (mind_map_get_type ())
#define MIND_MAP(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_MIND_MAP, MindMap))
#define MIND_MAP_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_MIND_MAP, MindMapClass))
#define IS_MIND_MAP(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_MIND_MAP))
#define IS_MIND_MAP_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_MIND_MAP))
#define MIND_MAP_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_MIND_MAP, MindMapClass))

typedef struct _MindMap MindMap;
typedef struct _MindMapClass MindMapClass;
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))

#define TYPE_PROPERTIES (properties_get_type ())
#define PROPERTIES(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_PROPERTIES, Properties))
#define PROPERTIES_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_PROPERTIES, PropertiesClass))
#define IS_PROPERTIES(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_PROPERTIES))
#define IS_PROPERTIES_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_PROPERTIES))
#define PROPERTIES_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_PROPERTIES, PropertiesClass))

typedef struct _Properties Properties;
typedef struct _PropertiesClass PropertiesClass;
typedef struct _PropertiesPrivate PropertiesPrivate;

#define TYPE_MAP_WIDGETS (map_widgets_get_type ())
#define MAP_WIDGETS(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_MAP_WIDGETS, MapWidgets))
#define MAP_WIDGETS_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_MAP_WIDGETS, MapWidgetsClass))
#define IS_MAP_WIDGETS(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_MAP_WIDGETS))
#define IS_MAP_WIDGETS_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_MAP_WIDGETS))
#define MAP_WIDGETS_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_MAP_WIDGETS, MapWidgetsClass))

typedef struct _MapWidgets MapWidgets;
typedef struct _MapWidgetsClass MapWidgetsClass;

#define TYPE_PROPERTIES_WIDGETS (properties_widgets_get_type ())
#define PROPERTIES_WIDGETS(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_PROPERTIES_WIDGETS, PropertiesWidgets))
#define PROPERTIES_WIDGETS_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_PROPERTIES_WIDGETS, PropertiesWidgetsClass))
#define IS_PROPERTIES_WIDGETS(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_PROPERTIES_WIDGETS))
#define IS_PROPERTIES_WIDGETS_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_PROPERTIES_WIDGETS))
#define PROPERTIES_WIDGETS_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_PROPERTIES_WIDGETS, PropertiesWidgetsClass))

typedef struct _PropertiesWidgets PropertiesWidgets;
typedef struct _PropertiesWidgetsClass PropertiesWidgetsClass;
#define _xmlFreeTextWriter0(var) ((var == NULL) ? NULL : (var = (xmlFreeTextWriter (var), NULL)))
#define _cairo_destroy0(var) ((var == NULL) ? NULL : (var = (cairo_destroy (var), NULL)))
#define _cairo_surface_destroy0(var) ((var == NULL) ? NULL : (var = (cairo_surface_destroy (var), NULL)))

typedef enum  {
	EXPORTER_EXPORT_ERROR_NOT_SUPPORT_YET
} ExporterExportError;
#define EXPORTER_EXPORT_ERROR exporter_export_error_quark ()
struct _Node {
	GObject parent_instance;
	NodePrivate * priv;
	GdkDrawable* window;
	Node* parent;
	MindMap* map;
	GList* children;
	gchar* text;
	guint direction;
	gdouble weight;
	gdouble points;
	gint function;
	GdkColor color;
	GdkRectangle area;
	GdkRectangle full_left;
	GdkRectangle full_right;
	PangoFontDescription* font_desc;
	gboolean is_expand;
	gboolean visible;
	gboolean default_color;
	GeeHashSet* flags;
};

struct _NodeClass {
	GObjectClass parent_class;
};

struct _Properties {
	GObject parent_instance;
	PropertiesPrivate * priv;
	PropertiesWidgets* pw;
	gchar* author;
	time_t created;
	time_t modified;
	gchar* filepath;
	guint rise_method;
	gboolean rise_ideas;
	gboolean rise_branches;
};

struct _PropertiesClass {
	GObjectClass parent_class;
};



GQuark exporter_export_error_quark (void);
GType node_get_type (void) G_GNUC_CONST;
void exporter_write_txt (GDataOutputStream* dos, Node* node, gint lvl, GError** error);
GType mind_map_get_type (void) G_GNUC_CONST;
const gchar* node_get_str_points (Node* self);
const gchar* node_get_title (Node* self);
gboolean exporter_export_to_txt (const gchar* path, Node* root);
void exporter_write_html_node (xmlTextWriter* w, Node* node);
gchar* node_get_color (Node* self);
void exporter_write_html_meta (xmlTextWriter* w, ...);
GType properties_get_type (void) G_GNUC_CONST;
gboolean exporter_export_to_html (const gchar* path, Node* root, Properties* prop);
#define PROGRAM "mmarchitect"
GType map_widgets_get_type (void) G_GNUC_CONST;
GType properties_widgets_get_type (void) G_GNUC_CONST;
gboolean exporter_export_to_dhtml (const gchar* path, Node* root);
gboolean exporter_export_to_mm (const gchar* path, Node* root);
void exporter_cairo_get_translation (gint width, gint height, Node* node, gdouble* x, gdouble* y);
gint node_get_higher_full (Node* self);
gboolean exporter_export_to_png (const gchar* path, Node* node);
void node_draw_tree (Node* self, cairo_t* cr);


GQuark exporter_export_error_quark (void) {
	return g_quark_from_static_string ("exporter_export_error-quark");
}


static gpointer _g_object_ref0 (gpointer self) {
	return self ? g_object_ref (self) : NULL;
}


void exporter_write_txt (GDataOutputStream* dos, Node* node, gint lvl, GError** error) {
	GDataOutputStream* _tmp0_;
	gint _tmp1_;
	gchar* _tmp2_ = NULL;
	gchar* _tmp3_;
	gint _tmp4_;
	gchar* _tmp6_ = NULL;
	Node* _tmp7_;
	gdouble _tmp8_;
	const gchar* _tmp16_;
	gchar* _tmp17_;
	gchar* points;
	GDataOutputStream* _tmp18_;
	Node* _tmp19_;
	const gchar* _tmp20_;
	const gchar* _tmp21_;
	const gchar* _tmp22_;
	gchar* _tmp23_;
	gchar* _tmp24_;
	gchar* _tmp25_;
	gchar* _tmp26_;
	Node* _tmp27_;
	const gchar* _tmp28_;
	gint _tmp29_;
	gint _tmp30_;
	Node* _tmp40_;
	GList* _tmp41_;
	GError * _inner_error_ = NULL;
	g_return_if_fail (dos != NULL);
	g_return_if_fail (node != NULL);
	_tmp0_ = dos;
	_tmp1_ = lvl;
	_tmp2_ = g_strnfill ((gsize) (_tmp1_ * 2), ' ');
	_tmp3_ = _tmp2_;
	g_data_output_stream_put_string (_tmp0_, _tmp3_, NULL, &_inner_error_);
	_g_free0 (_tmp3_);
	if (_inner_error_ != NULL) {
		if (_inner_error_->domain == G_IO_ERROR) {
			g_propagate_error (error, _inner_error_);
			return;
		} else {
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
			g_clear_error (&_inner_error_);
			return;
		}
	}
	_tmp4_ = lvl;
	if (_tmp4_ > 0) {
		GDataOutputStream* _tmp5_;
		_tmp5_ = dos;
		g_data_output_stream_put_string (_tmp5_, " * ", NULL, &_inner_error_);
		if (_inner_error_ != NULL) {
			if (_inner_error_->domain == G_IO_ERROR) {
				g_propagate_error (error, _inner_error_);
				return;
			} else {
				g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
				g_clear_error (&_inner_error_);
				return;
			}
		}
	}
	_tmp7_ = node;
	_tmp8_ = _tmp7_->points;
	if (_tmp8_ > ((gdouble) 0)) {
		Node* _tmp9_;
		const gchar* _tmp10_;
		const gchar* _tmp11_;
		gchar* _tmp12_;
		gchar* _tmp13_;
		gchar* _tmp14_;
		_tmp9_ = node;
		_tmp10_ = node_get_str_points (_tmp9_);
		_tmp11_ = _tmp10_;
		_tmp12_ = g_strconcat (" [", _tmp11_, NULL);
		_tmp13_ = _tmp12_;
		_tmp14_ = g_strconcat (_tmp13_, "]", NULL);
		_g_free0 (_tmp6_);
		_tmp6_ = _tmp14_;
		_g_free0 (_tmp13_);
	} else {
		gchar* _tmp15_;
		_tmp15_ = g_strdup ("");
		_g_free0 (_tmp6_);
		_tmp6_ = _tmp15_;
	}
	_tmp16_ = _tmp6_;
	_tmp17_ = g_strdup (_tmp16_);
	points = _tmp17_;
	_tmp18_ = dos;
	_tmp19_ = node;
	_tmp20_ = node_get_title (_tmp19_);
	_tmp21_ = _tmp20_;
	_tmp22_ = points;
	_tmp23_ = g_strconcat (_tmp21_, _tmp22_, NULL);
	_tmp24_ = _tmp23_;
	_tmp25_ = g_strconcat (_tmp24_, "\n", NULL);
	_tmp26_ = _tmp25_;
	g_data_output_stream_put_string (_tmp18_, _tmp26_, NULL, &_inner_error_);
	_g_free0 (_tmp26_);
	_g_free0 (_tmp24_);
	if (_inner_error_ != NULL) {
		if (_inner_error_->domain == G_IO_ERROR) {
			g_propagate_error (error, _inner_error_);
			_g_free0 (points);
			_g_free0 (_tmp6_);
			return;
		} else {
			_g_free0 (points);
			_g_free0 (_tmp6_);
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
			g_clear_error (&_inner_error_);
			return;
		}
	}
	_tmp27_ = node;
	_tmp28_ = _tmp27_->text;
	_tmp29_ = strlen (_tmp28_);
	_tmp30_ = _tmp29_;
	if (_tmp30_ > 0) {
		GDataOutputStream* _tmp31_;
		gint _tmp32_;
		gchar* _tmp33_ = NULL;
		gchar* _tmp34_;
		GDataOutputStream* _tmp35_;
		Node* _tmp36_;
		const gchar* _tmp37_;
		gchar* _tmp38_;
		gchar* _tmp39_;
		_tmp31_ = dos;
		_tmp32_ = lvl;
		_tmp33_ = g_strnfill ((gsize) ((_tmp32_ * 2) + 3), ' ');
		_tmp34_ = _tmp33_;
		g_data_output_stream_put_string (_tmp31_, _tmp34_, NULL, &_inner_error_);
		_g_free0 (_tmp34_);
		if (_inner_error_ != NULL) {
			if (_inner_error_->domain == G_IO_ERROR) {
				g_propagate_error (error, _inner_error_);
				_g_free0 (points);
				_g_free0 (_tmp6_);
				return;
			} else {
				_g_free0 (points);
				_g_free0 (_tmp6_);
				g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
				g_clear_error (&_inner_error_);
				return;
			}
		}
		_tmp35_ = dos;
		_tmp36_ = node;
		_tmp37_ = _tmp36_->text;
		_tmp38_ = g_strconcat (_tmp37_, "\n", NULL);
		_tmp39_ = _tmp38_;
		g_data_output_stream_put_string (_tmp35_, _tmp39_, NULL, &_inner_error_);
		_g_free0 (_tmp39_);
		if (_inner_error_ != NULL) {
			if (_inner_error_->domain == G_IO_ERROR) {
				g_propagate_error (error, _inner_error_);
				_g_free0 (points);
				_g_free0 (_tmp6_);
				return;
			} else {
				_g_free0 (points);
				_g_free0 (_tmp6_);
				g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
				g_clear_error (&_inner_error_);
				return;
			}
		}
	}
	_tmp40_ = node;
	_tmp41_ = _tmp40_->children;
	{
		GList* it_collection = NULL;
		GList* it_it = NULL;
		it_collection = _tmp41_;
		for (it_it = it_collection; it_it != NULL; it_it = it_it->next) {
			Node* _tmp42_;
			Node* it = NULL;
			_tmp42_ = _g_object_ref0 ((Node*) it_it->data);
			it = _tmp42_;
			{
				GDataOutputStream* _tmp43_;
				Node* _tmp44_;
				gint _tmp45_;
				_tmp43_ = dos;
				_tmp44_ = it;
				_tmp45_ = lvl;
				exporter_write_txt (_tmp43_, _tmp44_, _tmp45_ + 1, &_inner_error_);
				if (_inner_error_ != NULL) {
					if (_inner_error_->domain == G_IO_ERROR) {
						g_propagate_error (error, _inner_error_);
						_g_object_unref0 (it);
						_g_free0 (points);
						_g_free0 (_tmp6_);
						return;
					} else {
						_g_object_unref0 (it);
						_g_free0 (points);
						_g_free0 (_tmp6_);
						g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
						g_clear_error (&_inner_error_);
						return;
					}
				}
				_g_object_unref0 (it);
			}
		}
	}
	_g_free0 (points);
	_g_free0 (_tmp6_);
}


gboolean exporter_export_to_txt (const gchar* path, Node* root) {
	gboolean result = FALSE;
	GError * _inner_error_ = NULL;
	g_return_val_if_fail (path != NULL, FALSE);
	g_return_val_if_fail (root != NULL, FALSE);
	{
		const gchar* _tmp0_;
		GFile* _tmp1_ = NULL;
		GFile* file;
		GFile* _tmp2_;
		GFileOutputStream* _tmp3_ = NULL;
		GFileOutputStream* _tmp4_;
		GFileOutputStream* _tmp5_;
		GDataOutputStream* _tmp6_;
		GDataOutputStream* _tmp7_;
		GDataOutputStream* dos;
		GDataOutputStream* _tmp8_;
		Node* _tmp9_;
		_tmp0_ = path;
		_tmp1_ = g_file_new_for_path (_tmp0_);
		file = _tmp1_;
		_tmp2_ = file;
		_tmp3_ = g_file_replace (_tmp2_, NULL, FALSE, G_FILE_CREATE_REPLACE_DESTINATION, NULL, &_inner_error_);
		_tmp4_ = _tmp3_;
		if (_inner_error_ != NULL) {
			_g_object_unref0 (file);
			goto __catch8_g_error;
		}
		_tmp5_ = _tmp4_;
		_tmp6_ = g_data_output_stream_new ((GOutputStream*) _tmp5_);
		_tmp7_ = _tmp6_;
		_g_object_unref0 (_tmp5_);
		dos = _tmp7_;
		_tmp8_ = dos;
		_tmp9_ = root;
		exporter_write_txt (_tmp8_, _tmp9_, 0, &_inner_error_);
		if (_inner_error_ != NULL) {
			_g_object_unref0 (dos);
			_g_object_unref0 (file);
			goto __catch8_g_error;
		}
		result = TRUE;
		_g_object_unref0 (dos);
		_g_object_unref0 (file);
		return result;
	}
	goto __finally8;
	__catch8_g_error:
	{
		GError* e = NULL;
		FILE* _tmp10_;
		GError* _tmp11_;
		const gchar* _tmp12_;
		e = _inner_error_;
		_inner_error_ = NULL;
		_tmp10_ = stderr;
		_tmp11_ = e;
		_tmp12_ = _tmp11_->message;
		fprintf (_tmp10_, "%s\n", _tmp12_);
		result = FALSE;
		_g_error_free0 (e);
		return result;
	}
	__finally8:
	g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
	g_clear_error (&_inner_error_);
	return FALSE;
}


static gchar* double_to_string (gdouble self) {
	gchar* result = NULL;
	gchar* _tmp0_ = NULL;
	gchar* _tmp1_;
	gint _tmp1__length1;
	const gchar* _tmp2_ = NULL;
	gchar* _tmp3_;
	gchar* _tmp4_;
	_tmp0_ = g_new0 (gchar, G_ASCII_DTOSTR_BUF_SIZE);
	_tmp1_ = _tmp0_;
	_tmp1__length1 = G_ASCII_DTOSTR_BUF_SIZE;
	_tmp2_ = g_ascii_dtostr (_tmp1_, G_ASCII_DTOSTR_BUF_SIZE, self);
	_tmp3_ = g_strdup (_tmp2_);
	_tmp4_ = _tmp3_;
	_tmp1_ = (g_free (_tmp1_), NULL);
	result = _tmp4_;
	return result;
}


void exporter_write_html_node (xmlTextWriter* w, Node* node) {
	xmlTextWriter* _tmp0_;
	gboolean _tmp1_ = FALSE;
	Node* _tmp2_;
	Node* _tmp3_;
	gboolean _tmp6_;
	xmlTextWriter* _tmp32_;
	Node* _tmp33_;
	const gchar* _tmp34_;
	const gchar* _tmp35_;
	Node* _tmp36_;
	gdouble _tmp37_;
	Node* _tmp43_;
	const gchar* _tmp44_;
	Node* _tmp49_;
	GList* _tmp50_;
	guint _tmp51_ = 0U;
	Node* _tmp54_;
	GList* _tmp55_;
	Node* _tmp59_;
	GList* _tmp60_;
	guint _tmp61_ = 0U;
	xmlTextWriter* _tmp63_;
	g_return_if_fail (w != NULL);
	g_return_if_fail (node != NULL);
	_tmp0_ = w;
	xmlTextWriterStartElement (_tmp0_, "li");
	_tmp2_ = node;
	_tmp3_ = _tmp2_->parent;
	if (_tmp3_ == NULL) {
		Node* _tmp4_;
		gboolean _tmp5_;
		_tmp4_ = node;
		_tmp5_ = _tmp4_->default_color;
		_tmp1_ = !_tmp5_;
	} else {
		_tmp1_ = FALSE;
	}
	_tmp6_ = _tmp1_;
	if (_tmp6_) {
		xmlTextWriter* _tmp7_;
		Node* _tmp8_;
		gchar* _tmp9_ = NULL;
		gchar* _tmp10_;
		gchar* _tmp11_;
		gchar* _tmp12_;
		gchar* _tmp13_;
		gchar* _tmp14_;
		_tmp7_ = w;
		_tmp8_ = node;
		_tmp9_ = node_get_color (_tmp8_);
		_tmp10_ = _tmp9_;
		_tmp11_ = g_strconcat ("color:", _tmp10_, NULL);
		_tmp12_ = _tmp11_;
		_tmp13_ = g_strconcat (_tmp12_, ";", NULL);
		_tmp14_ = _tmp13_;
		xmlTextWriterWriteAttribute (_tmp7_, "style", _tmp14_);
		_g_free0 (_tmp14_);
		_g_free0 (_tmp12_);
		_g_free0 (_tmp10_);
	} else {
		gboolean _tmp15_ = FALSE;
		Node* _tmp16_;
		Node* _tmp17_;
		gboolean _tmp23_;
		_tmp16_ = node;
		_tmp17_ = _tmp16_->parent;
		if (_tmp17_ != NULL) {
			Node* _tmp18_;
			Node* _tmp19_;
			Node* _tmp20_;
			GdkColor _tmp21_;
			gboolean _tmp22_ = FALSE;
			_tmp18_ = node;
			_tmp19_ = node;
			_tmp20_ = _tmp19_->parent;
			_tmp21_ = _tmp20_->color;
			_tmp22_ = gdk_color_equal (&_tmp18_->color, &_tmp21_);
			_tmp15_ = !_tmp22_;
		} else {
			_tmp15_ = FALSE;
		}
		_tmp23_ = _tmp15_;
		if (_tmp23_) {
			xmlTextWriter* _tmp24_;
			Node* _tmp25_;
			gchar* _tmp26_ = NULL;
			gchar* _tmp27_;
			gchar* _tmp28_;
			gchar* _tmp29_;
			gchar* _tmp30_;
			gchar* _tmp31_;
			_tmp24_ = w;
			_tmp25_ = node;
			_tmp26_ = node_get_color (_tmp25_);
			_tmp27_ = _tmp26_;
			_tmp28_ = g_strconcat ("color:", _tmp27_, NULL);
			_tmp29_ = _tmp28_;
			_tmp30_ = g_strconcat (_tmp29_, ";", NULL);
			_tmp31_ = _tmp30_;
			xmlTextWriterWriteAttribute (_tmp24_, "style", _tmp31_);
			_g_free0 (_tmp31_);
			_g_free0 (_tmp29_);
			_g_free0 (_tmp27_);
		}
	}
	_tmp32_ = w;
	_tmp33_ = node;
	_tmp34_ = node_get_title (_tmp33_);
	_tmp35_ = _tmp34_;
	xmlTextWriterWriteString (_tmp32_, _tmp35_);
	_tmp36_ = node;
	_tmp37_ = _tmp36_->points;
	if (_tmp37_ != ((gdouble) 0)) {
		xmlTextWriter* _tmp38_;
		Node* _tmp39_;
		gdouble _tmp40_;
		gchar* _tmp41_ = NULL;
		gchar* _tmp42_;
		_tmp38_ = w;
		_tmp39_ = node;
		_tmp40_ = _tmp39_->points;
		_tmp41_ = double_to_string (_tmp40_);
		_tmp42_ = _tmp41_;
		xmlTextWriterWriteAttribute (_tmp38_, "points", _tmp42_);
		_g_free0 (_tmp42_);
	}
	_tmp43_ = node;
	_tmp44_ = _tmp43_->text;
	if (g_strcmp0 (_tmp44_, "") != 0) {
		xmlTextWriter* _tmp45_;
		xmlTextWriter* _tmp46_;
		Node* _tmp47_;
		const gchar* _tmp48_;
		_tmp45_ = w;
		xmlTextWriterWriteString (_tmp45_, "\n");
		_tmp46_ = w;
		_tmp47_ = node;
		_tmp48_ = _tmp47_->text;
		xmlTextWriterWriteElement (_tmp46_, "p", _tmp48_);
	}
	_tmp49_ = node;
	_tmp50_ = _tmp49_->children;
	_tmp51_ = g_list_length (_tmp50_);
	if (_tmp51_ > ((guint) 0)) {
		xmlTextWriter* _tmp52_;
		xmlTextWriter* _tmp53_;
		_tmp52_ = w;
		xmlTextWriterWriteString (_tmp52_, "\n");
		_tmp53_ = w;
		xmlTextWriterStartElement (_tmp53_, "ul");
	}
	_tmp54_ = node;
	_tmp55_ = _tmp54_->children;
	{
		GList* n_collection = NULL;
		GList* n_it = NULL;
		n_collection = _tmp55_;
		for (n_it = n_collection; n_it != NULL; n_it = n_it->next) {
			Node* _tmp56_;
			Node* n = NULL;
			_tmp56_ = _g_object_ref0 ((Node*) n_it->data);
			n = _tmp56_;
			{
				xmlTextWriter* _tmp57_;
				Node* _tmp58_;
				_tmp57_ = w;
				_tmp58_ = n;
				exporter_write_html_node (_tmp57_, _tmp58_);
				_g_object_unref0 (n);
			}
		}
	}
	_tmp59_ = node;
	_tmp60_ = _tmp59_->children;
	_tmp61_ = g_list_length (_tmp60_);
	if (_tmp61_ > ((guint) 0)) {
		xmlTextWriter* _tmp62_;
		_tmp62_ = w;
		xmlTextWriterEndElement (_tmp62_);
	}
	_tmp63_ = w;
	xmlTextWriterEndElement (_tmp63_);
}


void exporter_write_html_meta (xmlTextWriter* w, ...) {
	xmlTextWriter* _tmp0_;
	va_list args = {0};
	xmlTextWriter* _tmp10_;
	g_return_if_fail (w != NULL);
	_tmp0_ = w;
	xmlTextWriterStartElement (_tmp0_, "meta");
	va_start (args, w);
	while (TRUE) {
		const gchar* _tmp1_ = NULL;
		gchar* _tmp2_;
		gchar* key;
		const gchar* _tmp3_;
		const gchar* _tmp4_ = NULL;
		gchar* _tmp5_;
		gchar* val;
		const gchar* _tmp6_;
		xmlTextWriter* _tmp7_;
		const gchar* _tmp8_;
		const gchar* _tmp9_;
		_tmp1_ = va_arg (args, gchar*);
		_tmp2_ = g_strdup (_tmp1_);
		key = _tmp2_;
		_tmp3_ = key;
		if (_tmp3_ == NULL) {
			_g_free0 (key);
			break;
		}
		_tmp4_ = va_arg (args, gchar*);
		_tmp5_ = g_strdup (_tmp4_);
		val = _tmp5_;
		_tmp6_ = val;
		if (_tmp6_ == NULL) {
			_g_free0 (val);
			_g_free0 (key);
			break;
		}
		_tmp7_ = w;
		_tmp8_ = key;
		_tmp9_ = val;
		xmlTextWriterWriteAttribute (_tmp7_, _tmp8_, _tmp9_);
		_g_free0 (val);
		_g_free0 (key);
	}
	_tmp10_ = w;
	xmlTextWriterEndElement (_tmp10_);
	va_end (args);
}


gboolean exporter_export_to_html (const gchar* path, Node* root, Properties* prop) {
	gboolean result = FALSE;
	const gchar* _tmp0_;
	xmlTextWriter* _tmp1_;
	xmlTextWriter* w;
	Properties* _tmp2_;
	const gchar* _tmp3_;
	Node* _tmp4_;
	const gchar* _tmp5_;
	const gchar* _tmp6_;
	Node* _tmp7_;
	g_return_val_if_fail (path != NULL, FALSE);
	g_return_val_if_fail (root != NULL, FALSE);
	g_return_val_if_fail (prop != NULL, FALSE);
	_tmp0_ = path;
	_tmp1_ = xmlNewTextWriterFilename (_tmp0_, FALSE);
	w = _tmp1_;
	xmlTextWriterSetIndent (w, TRUE);
	xmlTextWriterSetIndentString (w, " ");
	xmlTextWriterStartElement (w, "html");
	xmlTextWriterStartElement (w, "head");
	exporter_write_html_meta (w, "charset", "utf-8", NULL);
	exporter_write_html_meta (w, "name", "generator", "content", PROGRAM, NULL);
	_tmp2_ = prop;
	_tmp3_ = _tmp2_->author;
	exporter_write_html_meta (w, "name", "author", "content", _tmp3_, NULL);
	_tmp4_ = root;
	_tmp5_ = node_get_title (_tmp4_);
	_tmp6_ = _tmp5_;
	xmlTextWriterWriteElement (w, "title", _tmp6_);
	xmlTextWriterEndElement (w);
	xmlTextWriterStartElement (w, "body");
	_tmp7_ = root;
	exporter_write_html_node (w, _tmp7_);
	xmlTextWriterEndElement (w);
	xmlTextWriterEndElement (w);
	xmlTextWriterFlush (w);
	result = TRUE;
	_xmlFreeTextWriter0 (w);
	return result;
}


gboolean exporter_export_to_dhtml (const gchar* path, Node* root) {
	gboolean result = FALSE;
	GError * _inner_error_ = NULL;
	g_return_val_if_fail (path != NULL, FALSE);
	g_return_val_if_fail (root != NULL, FALSE);
	{
		GError* _tmp0_;
		_tmp0_ = g_error_new_literal (EXPORTER_EXPORT_ERROR, EXPORTER_EXPORT_ERROR_NOT_SUPPORT_YET, "DHTML is not support yet!");
		_inner_error_ = _tmp0_;
		goto __catch9_g_error;
	}
	goto __finally9;
	__catch9_g_error:
	{
		GError* e = NULL;
		FILE* _tmp1_;
		const gchar* _tmp2_;
		e = _inner_error_;
		_inner_error_ = NULL;
		_tmp1_ = stderr;
		_tmp2_ = e->message;
		fprintf (_tmp1_, "%s\n", _tmp2_);
		result = FALSE;
		_g_error_free0 (e);
		return result;
	}
	__finally9:
	g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
	g_clear_error (&_inner_error_);
	return FALSE;
}


gboolean exporter_export_to_mm (const gchar* path, Node* root) {
	gboolean result = FALSE;
	GError * _inner_error_ = NULL;
	g_return_val_if_fail (path != NULL, FALSE);
	g_return_val_if_fail (root != NULL, FALSE);
	{
		GError* _tmp0_;
		_tmp0_ = g_error_new_literal (EXPORTER_EXPORT_ERROR, EXPORTER_EXPORT_ERROR_NOT_SUPPORT_YET, "FreeMind is not support yet!");
		_inner_error_ = _tmp0_;
		goto __catch10_g_error;
	}
	goto __finally10;
	__catch10_g_error:
	{
		GError* e = NULL;
		FILE* _tmp1_;
		const gchar* _tmp2_;
		e = _inner_error_;
		_inner_error_ = NULL;
		_tmp1_ = stderr;
		_tmp2_ = e->message;
		fprintf (_tmp1_, "%s\n", _tmp2_);
		result = FALSE;
		_g_error_free0 (e);
		return result;
	}
	__finally10:
	g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
	g_clear_error (&_inner_error_);
	return FALSE;
}


void exporter_cairo_get_translation (gint width, gint height, Node* node, gdouble* x, gdouble* y) {
	gdouble _vala_x = 0.0;
	gdouble _vala_y = 0.0;
	Node* _tmp0_;
	GdkRectangle _tmp1_;
	gint _tmp2_;
	Node* _tmp3_;
	GdkRectangle _tmp4_;
	gint _tmp5_;
	gint _tmp6_ = 0;
	gint dist;
	Node* _tmp7_;
	GdkRectangle _tmp8_;
	gint _tmp9_;
	Node* _tmp10_;
	GdkRectangle _tmp11_;
	gint _tmp12_;
	gint _tmp19_;
	Node* _tmp20_;
	gint _tmp21_ = 0;
	glong _tmp22_ = 0L;
	g_return_if_fail (node != NULL);
	_tmp0_ = node;
	_tmp1_ = _tmp0_->full_right;
	_tmp2_ = _tmp1_.width;
	_tmp3_ = node;
	_tmp4_ = _tmp3_->full_left;
	_tmp5_ = _tmp4_.width;
	_tmp6_ = abs (_tmp2_ - _tmp5_);
	dist = _tmp6_ / 2;
	_tmp7_ = node;
	_tmp8_ = _tmp7_->full_right;
	_tmp9_ = _tmp8_.width;
	_tmp10_ = node;
	_tmp11_ = _tmp10_->full_left;
	_tmp12_ = _tmp11_.width;
	if (_tmp9_ > _tmp12_) {
		gint _tmp13_;
		gint _tmp14_;
		glong _tmp15_ = 0L;
		_tmp13_ = width;
		_tmp14_ = dist;
		_tmp15_ = lrint ((gdouble) ((_tmp13_ / 2) - _tmp14_));
		_vala_x = _tmp15_ + 0.5;
	} else {
		gint _tmp16_;
		gint _tmp17_;
		glong _tmp18_ = 0L;
		_tmp16_ = width;
		_tmp17_ = dist;
		_tmp18_ = lrint ((gdouble) ((_tmp16_ / 2) + _tmp17_));
		_vala_x = _tmp18_ + 0.5;
	}
	_tmp19_ = height;
	_tmp20_ = node;
	_tmp21_ = node_get_higher_full (_tmp20_);
	_tmp22_ = lrint ((gdouble) ((_tmp19_ / 2) - (_tmp21_ / 2)));
	_vala_y = _tmp22_ + 0.5;
	if (x) {
		*x = _vala_x;
	}
	if (y) {
		*y = _vala_y;
	}
}


gboolean exporter_export_to_png (const gchar* path, Node* node) {
	gboolean result = FALSE;
	gint width = 0;
	gint height = 0;
	Node* _tmp0_;
	GdkDrawable* _tmp1_;
	gint _tmp2_ = 0;
	gint _tmp3_ = 0;
	cairo_surface_t* _tmp4_;
	cairo_surface_t* surface;
	cairo_t* _tmp5_;
	cairo_t* cr;
	gdouble x = 0.0;
	gdouble y = 0.0;
	Node* _tmp6_;
	gdouble _tmp7_ = 0.0;
	gdouble _tmp8_ = 0.0;
	Node* _tmp9_;
	const gchar* _tmp10_;
	cairo_status_t _tmp11_ = 0;
	cairo_status_t status;
	g_return_val_if_fail (path != NULL, FALSE);
	g_return_val_if_fail (node != NULL, FALSE);
	_tmp0_ = node;
	_tmp1_ = _tmp0_->window;
	gdk_drawable_get_size (_tmp1_, &_tmp2_, &_tmp3_);
	width = _tmp2_;
	height = _tmp3_;
	_tmp4_ = cairo_image_surface_create (CAIRO_FORMAT_RGB24, width, height);
	surface = _tmp4_;
	_tmp5_ = cairo_create (surface);
	cr = _tmp5_;
	cairo_rectangle (cr, (gdouble) 0, (gdouble) 0, (gdouble) width, (gdouble) height);
	cairo_set_source_rgb (cr, (gdouble) 1, (gdouble) 1, (gdouble) 1);
	cairo_fill_preserve (cr);
	_tmp6_ = node;
	exporter_cairo_get_translation (width, height, _tmp6_, &_tmp7_, &_tmp8_);
	x = _tmp7_;
	y = _tmp8_;
	cairo_translate (cr, x, y);
	_tmp9_ = node;
	node_draw_tree (_tmp9_, cr);
	_tmp10_ = path;
	_tmp11_ = cairo_surface_write_to_png (surface, _tmp10_);
	status = _tmp11_;
	result = status == CAIRO_STATUS_SUCCESS;
	_cairo_destroy0 (cr);
	_cairo_surface_destroy0 (surface);
	return result;
}



